diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.6.pl /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/js/media-models.js /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/js/media-models.js
*** /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/js/media-models.js	2012-12-05 23:06:49.000000000 -0600
--- /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/js/media-models.js	2013-07-27 02:09:05.000000000 -0500
***************
*** 72,161 ****
  		 * media.template( id )
  		 *
  		 * Fetches a template by id.
! 		 *
! 		 * @param  {string} id   A string that corresponds to a DOM element with an id prefixed with "tmpl-".
! 		 *                       For example, "attachment" maps to "tmpl-attachment".
! 		 * @return {function}    A function that lazily-compiles the template requested.
  		 */
! 		template: _.memoize( function( id ) {
! 			var compiled,
! 				options = {
! 					evaluate:    /<#([\s\S]+?)#>/g,
! 					interpolate: /\{\{\{([\s\S]+?)\}\}\}/g,
! 					escape:      /\{\{([^\}]+?)\}\}(?!\})/g,
! 					variable:    'data'
! 				};
! 
! 			return function( data ) {
! 				compiled = compiled || _.template( $( '#tmpl-' + id ).html(), null, options );
! 				return compiled( data );
! 			};
! 		}),
  
  		/**
  		 * media.post( [action], [data] )
  		 *
  		 * Sends a POST request to WordPress.
! 		 *
! 		 * @param  {string} action The slug of the action to fire in WordPress.
! 		 * @param  {object} data   The data to populate $_POST with.
! 		 * @return {$.promise}     A jQuery promise that represents the request.
  		 */
! 		post: function( action, data ) {
! 			return media.ajax({
! 				data: _.isObject( action ) ? action : _.extend( data || {}, { action: action })
! 			});
! 		},
  
  		/**
  		 * media.ajax( [action], [options] )
  		 *
! 		 * Sends a POST request to WordPress.
! 		 *
! 		 * @param  {string} action  The slug of the action to fire in WordPress.
! 		 * @param  {object} options The options passed to jQuery.ajax.
! 		 * @return {$.promise}      A jQuery promise that represents the request.
  		 */
! 		ajax: function( action, options ) {
! 			if ( _.isObject( action ) ) {
! 				options = action;
! 			} else {
! 				options = options || {};
! 				options.data = _.extend( options.data || {}, { action: action });
! 			}
! 
! 			options = _.defaults( options || {}, {
! 				type:    'POST',
! 				url:     media.model.settings.ajaxurl,
! 				context: this
! 			});
! 
! 			return $.Deferred( function( deferred ) {
! 				// Transfer success/error callbacks.
! 				if ( options.success )
! 					deferred.done( options.success );
! 				if ( options.error )
! 					deferred.fail( options.error );
! 
! 				delete options.success;
! 				delete options.error;
! 
! 				// Use with PHP's wp_send_json_success() and wp_send_json_error()
! 				$.ajax( options ).done( function( response ) {
! 					// Treat a response of `1` as successful for backwards
! 					// compatibility with existing handlers.
! 					if ( response === '1' || response === 1 )
! 						response = { success: true };
! 
! 					if ( _.isObject( response ) && ! _.isUndefined( response.success ) )
! 						deferred[ response.success ? 'resolveWith' : 'rejectWith' ]( this, [response.data] );
! 					else
! 						deferred.rejectWith( this, [response] );
! 				}).fail( function() {
! 					deferred.rejectWith( this, arguments );
! 				});
! 			}).promise();
! 		},
  
  		// Scales a set of dimensions to fit within bounding dimensions.
  		fit: function( dimensions ) {
--- 72,96 ----
  		 * media.template( id )
  		 *
  		 * Fetches a template by id.
! 		 * See wp.template() in `wp-includes/js/wp-util.js`.
  		 */
! 		template: wp.template,
  
  		/**
  		 * media.post( [action], [data] )
  		 *
  		 * Sends a POST request to WordPress.
! 		 * See wp.ajax.post() in `wp-includes/js/wp-util.js`.
  		 */
! 		post: wp.ajax.post,
  
  		/**
  		 * media.ajax( [action], [options] )
  		 *
! 		 * Sends an XHR request to WordPress.
! 		 * See wp.ajax.send() in `wp-includes/js/wp-util.js`.
  		 */
! 		ajax: wp.ajax.send,
  
  		// Scales a set of dimensions to fit within bounding dimensions.
  		fit: function( dimensions ) {
***************
*** 261,273 ****
  				});
  
  				// Record the values of the changed attributes.
! 				if ( options.changes ) {
! 					_.each( options.changes, function( value, key ) {
! 						options.changes[ key ] = this.get( key );
! 					}, this );
  
! 					options.data.changes = options.changes;
! 					delete options.changes;
  				}
  
  				return media.ajax( options );
--- 196,207 ----
  				});
  
  				// Record the values of the changed attributes.
! 				if ( model.hasChanged() ) {
! 					options.data.changes = {};
  
! 					_.each( model.changed, function( value, key ) {
! 						options.data.changes[ key ] = this.get( key );
! 					}, this );
  				}
  
  				return media.ajax( options );
***************
*** 292,297 ****
--- 226,235 ----
  				}).fail( function() {
  					this.destroyed = false;
  				});
+ 
+ 			// Otherwise, fall back to `Backbone.sync()`.
+ 			} else {
+ 				return Backbone.Model.prototype.sync.apply( this, arguments );
  			}
  		},
  
***************
*** 392,398 ****
  			if ( this.props.get('query') )
  				return;
  
! 			var changed = _.chain( options.changes ).map( function( t, prop ) {
  				var filter = Attachments.filters[ prop ],
  					term = model.get( prop );
  
--- 330,336 ----
  			if ( this.props.get('query') )
  				return;
  
! 			var changed = _.chain( model.changed ).map( function( t, prop ) {
  				var filter = Attachments.filters[ prop ],
  					term = model.get( prop );
  
***************
*** 434,440 ****
  
  		validate: function( attachment, options ) {
  			var valid = this.validator( attachment ),
! 				hasAttachment = !! this.getByCid( attachment.cid );
  
  			if ( ! valid && hasAttachment )
  				this.remove( attachment, options );
--- 372,378 ----
  
  		validate: function( attachment, options ) {
  			var valid = this.validator( attachment ),
! 				hasAttachment = !! this.get( attachment.cid );
  
  			if ( ! valid && hasAttachment )
  				this.remove( attachment, options );
***************
*** 545,553 ****
  		},
  
  		parse: function( resp, xhr ) {
  			return _.map( resp, function( attrs ) {
! 				var attachment = Attachment.get( attrs.id );
! 				return attachment.set( attachment.parse( attrs, xhr ) );
  			});
  		},
  
--- 482,507 ----
  		},
  
  		parse: function( resp, xhr ) {
+ 			if ( ! _.isArray( resp ) )
+ 				resp = [resp];
+ 
  			return _.map( resp, function( attrs ) {
! 				var id, attachment, newAttributes;
! 
! 				if ( attrs instanceof Backbone.Model ) {
! 					id = attrs.get( 'id' );
! 					attrs = attrs.attributes;
! 				} else {
! 					id = attrs.id;
! 				}
! 
! 				attachment = Attachment.get( id );
! 				newAttributes = attachment.parse( attrs, xhr );
! 
! 				if ( ! _.isEqual( attachment.attributes, newAttributes ) )
! 					attachment.set( newAttributes );
! 
! 				return attachment;
  			});
  		},
  
***************
*** 718,724 ****
  				return $.Deferred().resolveWith( this ).promise();
  
  			options = options || {};
! 			options.add = true;
  
  			return this._more = this.fetch( options ).done( function( resp ) {
  				if ( _.isEmpty( resp ) || -1 === this.args.posts_per_page || resp.length < this.args.posts_per_page )
--- 672,678 ----
  				return $.Deferred().resolveWith( this ).promise();
  
  			options = options || {};
! 			options.remove = false;
  
  			return this._more = this.fetch( options ).done( function( resp ) {
  				if ( _.isEmpty( resp ) || -1 === this.args.posts_per_page || resp.length < this.args.posts_per_page )
***************
*** 876,882 ****
  				this._single = model;
  
  			// If the single model isn't in the selection, remove it.
! 			if ( this._single && ! this.getByCid( this._single.cid ) )
  				delete this._single;
  
  			this._single = this._single || this.last();
--- 830,836 ----
  				this._single = model;
  
  			// If the single model isn't in the selection, remove it.
! 			if ( this._single && ! this.get( this._single.cid ) )
  				delete this._single;
  
  			this._single = this._single || this.last();
***************
*** 888,894 ****
  
  					// If the model was already removed, trigger the collection
  					// event manually.
! 					if ( ! this.getByCid( previous.cid ) )
  						this.trigger( 'selection:unsingle', previous, this );
  				}
  				if ( this._single )
--- 842,848 ----
  
  					// If the model was already removed, trigger the collection
  					// event manually.
! 					if ( ! this.get( previous.cid ) )
  						this.trigger( 'selection:unsingle', previous, this );
  				}
  				if ( this._single )
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.6.pl /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/js/media-views.js /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/js/media-views.js
*** /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/js/media-views.js	2013-01-04 20:02:29.000000000 -0600
--- /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/js/media-views.js	2013-07-23 12:29:55.000000000 -0500
***************
*** 223,232 ****
  			this.on( 'reset', this.reset, this );
  			this.on( 'ready', this._ready, this );
  			this.on( 'ready', this.ready, this );
- 
- 			this.on( 'change:menu', this._updateMenu, this );
- 
  			Backbone.Model.apply( this, arguments );
  		},
  
  		ready: function() {},
--- 223,230 ----
  			this.on( 'reset', this.reset, this );
  			this.on( 'ready', this._ready, this );
  			this.on( 'ready', this.ready, this );
  			Backbone.Model.apply( this, arguments );
+ 			this.on( 'change:menu', this._updateMenu, this );
  		},
  
  		ready: function() {},
***************
*** 451,461 ****
  			var displays = this._displays;
  
  			if ( ! displays[ attachment.cid ] )
! 				displays[ attachment.cid ] = new Backbone.Model( this._defaultDisplaySettings );
  
  			return displays[ attachment.cid ];
  		},
  
  		syncSelection: function() {
  			var selection = this.get('selection'),
  				manager = this.frame._selection;
--- 449,477 ----
  			var displays = this._displays;
  
  			if ( ! displays[ attachment.cid ] )
! 				displays[ attachment.cid ] = new Backbone.Model( this.defaultDisplaySettings( attachment ) );
  
  			return displays[ attachment.cid ];
  		},
  
+ 		defaultDisplaySettings: function( attachment ) {
+ 			settings = this._defaultDisplaySettings;
+ 			if ( settings.canEmbed = this.canEmbed( attachment ) )
+ 				settings.link = 'embed';
+ 			return settings;
+ 		},
+ 
+ 		canEmbed: function( attachment ) {
+ 			// If uploading, we know the filename but not the mime type.
+ 			if ( ! attachment.get('uploading') ) {
+ 				var type = attachment.get('type');
+ 				if ( type !== 'audio' && type !== 'video' )
+ 					return false;
+ 			}
+ 
+ 			return _.contains( media.view.settings.embedExts, attachment.get('filename').split('.').pop() );
+ 		},
+ 
  		syncSelection: function() {
  			var selection = this.get('selection'),
  				manager = this.frame._selection;
***************
*** 658,664 ****
  			// Accepts attachments that exist in the original library and
  			// that do not exist in gallery's library.
  			library.validator = function( attachment ) {
! 				return !! this.mirroring.getByCid( attachment.cid ) && ! edit.getByCid( attachment.cid ) && media.model.Selection.prototype.validator.apply( this, arguments );
  			};
  
  			// Reset the library to ensure that all attachments are re-added
--- 674,680 ----
  			// Accepts attachments that exist in the original library and
  			// that do not exist in gallery's library.
  			library.validator = function( attachment ) {
! 				return !! this.mirroring.get( attachment.cid ) && ! edit.get( attachment.cid ) && media.model.Selection.prototype.validator.apply( this, arguments );
  			};
  
  			// Reset the library to ensure that all attachments are re-added
***************
*** 701,708 ****
  			// Overload the library's comparator to push items that are not in
  			// the mirrored query to the front of the aggregate collection.
  			library.comparator = function( a, b ) {
! 				var aInQuery = !! this.mirroring.getByCid( a.cid ),
! 					bInQuery = !! this.mirroring.getByCid( b.cid );
  
  				if ( ! aInQuery && bInQuery )
  					return -1;
--- 717,724 ----
  			// Overload the library's comparator to push items that are not in
  			// the mirrored query to the front of the aggregate collection.
  			library.comparator = function( a, b ) {
! 				var aInQuery = !! this.mirroring.get( a.cid ),
! 					bInQuery = !! this.mirroring.get( b.cid );
  
  				if ( ! aInQuery && bInQuery )
  					return -1;
***************
*** 845,1199 ****
  	 * ========================================================================
  	 */
  
- 	// wp.media.Views
- 	// -------------
- 	//
- 	// A subview manager.
- 
- 	media.Views = function( view, views ) {
- 		this.view = view;
- 		this._views = _.isArray( views ) ? { '': views } : views || {};
- 	};
- 
- 	media.Views.extend = Backbone.Model.extend;
- 
- 	_.extend( media.Views.prototype, {
- 		// ### Fetch all of the subviews
- 		//
- 		// Returns an array of all subviews.
- 		all: function() {
- 			return _.flatten( this._views );
- 		},
- 
- 		// ### Get a selector's subviews
- 		//
- 		// Fetches all subviews that match a given `selector`.
- 		//
- 		// If no `selector` is provided, it will grab all subviews attached
- 		// to the view's root.
- 		get: function( selector ) {
- 			selector = selector || '';
- 			return this._views[ selector ];
- 		},
- 
- 		// ### Get a selector's first subview
- 		//
- 		// Fetches the first subview that matches a given `selector`.
- 		//
- 		// If no `selector` is provided, it will grab the first subview
- 		// attached to the view's root.
- 		//
- 		// Useful when a selector only has one subview at a time.
- 		first: function( selector ) {
- 			var views = this.get( selector );
- 			return views && views.length ? views[0] : null;
- 		},
- 
- 		// ### Register subview(s)
- 		//
- 		// Registers any number of `views` to a `selector`.
- 		//
- 		// When no `selector` is provided, the root selector (the empty string)
- 		// is used. `views` accepts a `Backbone.View` instance or an array of
- 		// `Backbone.View` instances.
- 		//
- 		// ---
- 		//
- 		// Accepts an `options` object, which has a significant effect on the
- 		// resulting behavior.
- 		//
- 		// `options.silent` &ndash; *boolean, `false`*
- 		// > If `options.silent` is true, no DOM modifications will be made.
- 		//
- 		// `options.add` &ndash; *boolean, `false`*
- 		// > Use `Views.add()` as a shortcut for setting `options.add` to true.
- 		//
- 		// > By default, the provided `views` will replace
- 		// any existing views associated with the selector. If `options.add`
- 		// is true, the provided `views` will be added to the existing views.
- 		//
- 		// `options.at` &ndash; *integer, `undefined`*
- 		// > When adding, to insert `views` at a specific index, use
- 		// `options.at`. By default, `views` are added to the end of the array.
- 		set: function( selector, views, options ) {
- 			var existing, next;
- 
- 			if ( ! _.isString( selector ) ) {
- 				options  = views;
- 				views    = selector;
- 				selector = '';
- 			}
- 
- 			options  = options || {};
- 			views    = _.isArray( views ) ? views : [ views ];
- 			existing = this.get( selector );
- 			next     = views;
- 
- 			if ( existing ) {
- 				if ( options.add ) {
- 					if ( _.isUndefined( options.at ) ) {
- 						next = existing.concat( views );
- 					} else {
- 						next = existing;
- 						next.splice.apply( next, [ options.at, 0 ].concat( views ) );
- 					}
- 				} else {
- 					_.each( next, function( view ) {
- 						view.__detach = true;
- 					});
- 
- 					_.each( existing, function( view ) {
- 						if ( view.__detach )
- 							view.$el.detach();
- 						else
- 							view.dispose();
- 					});
- 
- 					_.each( next, function( view ) {
- 						delete view.__detach;
- 					});
- 				}
- 			}
- 
- 			this._views[ selector ] = next;
- 
- 			_.each( views, function( subview ) {
- 				var constructor = subview.Views || media.Views,
- 					subviews = subview.views = subview.views || new constructor( subview );
- 				subviews.parent   = this.view;
- 				subviews.selector = selector;
- 			}, this );
- 
- 			if ( ! options.silent )
- 				this._attach( selector, views, _.extend({ ready: this._isReady() }, options ) );
- 
- 			return this;
- 		},
- 
- 		// ### Add subview(s) to existing subviews
- 		//
- 		// An alias to `Views.set()`, which defaults `options.add` to true.
- 		//
- 		// Adds any number of `views` to a `selector`.
- 		//
- 		// When no `selector` is provided, the root selector (the empty string)
- 		// is used. `views` accepts a `Backbone.View` instance or an array of
- 		// `Backbone.View` instances.
- 		//
- 		// Use `Views.set()` when setting `options.add` to `false`.
- 		//
- 		// Accepts an `options` object. By default, provided `views` will be
- 		// inserted at the end of the array of existing views. To insert
- 		// `views` at a specific index, use `options.at`. If `options.silent`
- 		// is true, no DOM modifications will be made.
- 		//
- 		// For more information on the `options` object, see `Views.set()`.
- 		add: function( selector, views, options ) {
- 			if ( ! _.isString( selector ) ) {
- 				options  = views;
- 				views    = selector;
- 				selector = '';
- 			}
- 
- 			return this.set( selector, views, _.extend({ add: true }, options ) );
- 		},
- 
- 		// ### Stop tracking subviews
- 		//
- 		// Stops tracking `views` registered to a `selector`. If no `views` are
- 		// set, then all of the `selector`'s subviews will be unregistered and
- 		// disposed.
- 		//
- 		// Accepts an `options` object. If `options.silent` is set, `dispose`
- 		// will *not* be triggered on the unregistered views.
- 		unset: function( selector, views, options ) {
- 			var existing;
- 
- 			if ( ! _.isString( selector ) ) {
- 				options = views;
- 				views = selector;
- 				selector = '';
- 			}
- 
- 			views = views || [];
- 
- 			if ( existing = this.get( selector ) ) {
- 				views = _.isArray( views ) ? views : [ views ];
- 				this._views[ selector ] = views.length ? _.difference( existing, views ) : [];
- 			}
- 
- 			if ( ! options || ! options.silent )
- 				_.invoke( views, 'dispose' );
- 
- 			return this;
- 		},
- 
- 		// ### Detach all subviews
- 		//
- 		// Detaches all subviews from the DOM.
- 		//
- 		// Helps to preserve all subview events when re-rendering the master
- 		// view. Used in conjunction with `Views.render()`.
- 		detach: function() {
- 			$( _.pluck( this.all(), 'el' ) ).detach();
- 			return this;
- 		},
- 
- 		// ### Render all subviews
- 		//
- 		// Renders all subviews. Used in conjunction with `Views.detach()`.
- 		render: function() {
- 			var options = {
- 					ready: this._isReady()
- 				};
- 
- 			_.each( this._views, function( views, selector ) {
- 				this._attach( selector, views, options );
- 			}, this );
- 
- 			this.rendered = true;
- 			return this;
- 		},
- 
- 		// ### Dispose all subviews
- 		//
- 		// Triggers the `dispose()` method on all subviews. Detaches the master
- 		// view from its parent. Resets the internals of the views manager.
- 		//
- 		// Accepts an `options` object. If `options.silent` is set, `unset`
- 		// will *not* be triggered on the master view's parent.
- 		dispose: function( options ) {
- 			if ( ! options || ! options.silent ) {
- 				if ( this.parent && this.parent.views )
- 					this.parent.views.unset( this.selector, this.view, { silent: true });
- 				delete this.parent;
- 				delete this.selector;
- 			}
- 
- 			_.invoke( this.all(), 'dispose' );
- 			this._views = [];
- 			return this;
- 		},
- 
- 		// ### Replace a selector's subviews
- 		//
- 		// By default, sets the `$target` selector's html to the subview `els`.
- 		//
- 		// Can be overridden in subclasses.
- 		replace: function( $target, els ) {
- 			$target.html( els );
- 			return this;
- 		},
- 
- 		// ### Insert subviews into a selector
- 		//
- 		// By default, appends the subview `els` to the end of the `$target`
- 		// selector. If `options.at` is set, inserts the subview `els` at the
- 		// provided index.
- 		//
- 		// Can be overridden in subclasses.
- 		insert: function( $target, els, options ) {
- 			var at = options && options.at,
- 				$children;
- 
- 			if ( _.isNumber( at ) && ($children = $target.children()).length > at )
- 				$children.eq( at ).before( els );
- 			else
- 				$target.append( els );
- 
- 			return this;
- 		},
- 
- 		// ### Trigger the ready event
- 		//
- 		// **Only use this method if you know what you're doing.**
- 		// For performance reasons, this method does not check if the view is
- 		// actually attached to the DOM. It's taking your word for it.
- 		//
- 		// Fires the ready event on the current view and all attached subviews.
- 		ready: function() {
- 			this.view.trigger('ready');
- 
- 			// Find all attached subviews, and call ready on them.
- 			_.chain( this.all() ).map( function( view ) {
- 				return view.views;
- 			}).flatten().where({ attached: true }).invoke('ready');
- 		},
- 
- 		// #### Internal. Attaches a series of views to a selector.
- 		//
- 		// Checks to see if a matching selector exists, renders the views,
- 		// performs the proper DOM operation, and then checks if the view is
- 		// attached to the document.
- 		_attach: function( selector, views, options ) {
- 			var $selector = selector ? this.view.$( selector ) : this.view.$el,
- 				managers;
- 
- 			// Check if we found a location to attach the views.
- 			if ( ! $selector.length )
- 				return this;
- 
- 			managers = _.chain( views ).pluck('views').flatten().value();
- 
- 			// Render the views if necessary.
- 			_.each( managers, function( manager ) {
- 				if ( manager.rendered )
- 					return;
- 
- 				manager.view.render();
- 				manager.rendered = true;
- 			}, this );
- 
- 			// Insert or replace the views.
- 			this[ options.add ? 'insert' : 'replace' ]( $selector, _.pluck( views, 'el' ), options );
- 
- 			// Set attached and trigger ready if the current view is already
- 			// attached to the DOM.
- 			_.each( managers, function( manager ) {
- 				manager.attached = true;
- 
- 				if ( options.ready )
- 					manager.ready();
- 			}, this );
- 
- 			return this;
- 		},
- 
- 		// #### Internal. Checks if the current view is in the DOM.
- 		_isReady: function() {
- 			var node = this.view.el;
- 			while ( node ) {
- 				if ( node === document.body )
- 					return true;
- 				node = node.parentNode;
- 			}
- 
- 			return false;
- 		}
- 	});
- 
  	// wp.media.View
  	// -------------
  	//
  	// The base view class.
! 	media.View = Backbone.View.extend({
! 		// The constructor for the `Views` manager.
! 		Views: media.Views,
! 
  		constructor: function( options ) {
- 			this.views = new this.Views( this, this.views );
- 			this.on( 'ready', this.ready, this );
- 
  			if ( options && options.controller )
  				this.controller = options.controller;
  
! 			Backbone.View.apply( this, arguments );
  		},
  
  		dispose: function() {
  			// Undelegating events, removing events from the model, and
  			// removing events from the controller mirror the code for
! 			// `Backbone.View.dispose` in Backbone master.
  			this.undelegateEvents();
  
  			if ( this.model && this.model.off )
--- 861,889 ----
  	 * ========================================================================
  	 */
  
  	// wp.media.View
  	// -------------
  	//
  	// The base view class.
! 	//
! 	// Undelegating events, removing events from the model, and
! 	// removing events from the controller mirror the code for
! 	// `Backbone.View.dispose` in Backbone 0.9.8 development.
! 	//
! 	// This behavior has since been removed, and should not be used
! 	// outside of the media manager.
! 	media.View = wp.Backbone.View.extend({
  		constructor: function( options ) {
  			if ( options && options.controller )
  				this.controller = options.controller;
  
! 			wp.Backbone.View.apply( this, arguments );
  		},
  
  		dispose: function() {
  			// Undelegating events, removing events from the model, and
  			// removing events from the controller mirror the code for
! 			// `Backbone.View.dispose` in Backbone 0.9.8 development.
  			this.undelegateEvents();
  
  			if ( this.model && this.model.off )
***************
*** 1206,1246 ****
  			if ( this.controller && this.controller.off )
  				this.controller.off( null, null, this );
  
- 			// Recursively dispose child views.
- 			if ( this.views )
- 				this.views.dispose();
- 
  			return this;
  		},
  
  		remove: function() {
  			this.dispose();
! 			return Backbone.View.prototype.remove.apply( this, arguments );
! 		},
! 
! 		render: function() {
! 			var options;
! 
! 			if ( this.prepare )
! 				options = this.prepare();
! 
! 			this.views.detach();
! 
! 			if ( this.template ) {
! 				options = options || {};
! 				this.trigger( 'prepare', options );
! 				this.$el.html( this.template( options ) );
! 			}
! 
! 			this.views.render();
! 			return this;
! 		},
! 
! 		prepare: function() {
! 			return this.options;
! 		},
! 
! 		ready: function() {}
  	});
  
  	/**
--- 896,908 ----
  			if ( this.controller && this.controller.off )
  				this.controller.off( null, null, this );
  
  			return this;
  		},
  
  		remove: function() {
  			this.dispose();
! 			return wp.Backbone.View.prototype.remove.apply( this, arguments );
! 		}
  	});
  
  	/**
***************
*** 1831,1837 ****
  		featuredImageToolbar: function( toolbar ) {
  			this.createSelectToolbar( toolbar, {
  				text:  l10n.setFeaturedImage,
! 				state: this.options.state || 'upload'
  			});
  		},
  
--- 1493,1499 ----
  		featuredImageToolbar: function( toolbar ) {
  			this.createSelectToolbar( toolbar, {
  				text:  l10n.setFeaturedImage,
! 				state: this.options.state
  			});
  		},
  
***************
*** 1859,1867 ****
  							controller.close();
  							state.trigger( 'update', state.get('library') );
  
  							controller.reset();
- 							// @todo: Make the state activated dynamic (instead of hardcoded).
- 							controller.setState('upload');
  						}
  					}
  				}
--- 1521,1529 ----
  							controller.close();
  							state.trigger( 'update', state.get('library') );
  
+ 							// Restore and reset the default state.
+ 							controller.setState( controller.options.state );
  							controller.reset();
  						}
  					}
  				}
***************
*** 2430,2435 ****
--- 2092,2102 ----
  				var requires = button.options.requires,
  					disabled = false;
  
+ 				// Prevent insertion of attachments if any of them are still uploading
+ 				disabled = _.some( selection.models, function( attachment ) {
+ 					return attachment.get('uploading') === true;
+ 				});
+ 
  				if ( requires.selection && selection && ! selection.length )
  					disabled = true;
  				else if ( requires.library && library && ! library.length )
***************
*** 2486,2496 ****
  			if ( options.event )
  				controller.state().trigger( options.event );
  
- 			if ( options.reset )
- 				controller.reset();
- 
  			if ( options.state )
  				controller.setState( options.state );
  		}
  	});
  
--- 2153,2163 ----
  			if ( options.event )
  				controller.state().trigger( options.event );
  
  			if ( options.state )
  				controller.setState( options.state );
+ 
+ 			if ( options.reset )
+ 				controller.reset();
  		}
  	});
  
***************
*** 3007,3013 ****
  		selected: function() {
  			var selection = this.options.selection;
  			if ( selection )
! 				return !! selection.getByCid( this.model.cid );
  		},
  
  		select: function( model, collection ) {
--- 2674,2680 ----
  		selected: function() {
  			var selection = this.options.selection;
  			if ( selection )
! 				return !! selection.get( this.model.cid );
  		},
  
  		select: function( model, collection ) {
***************
*** 3234,3240 ****
  
  			this.collection.on( 'add', function( attachment, attachments, options ) {
  				this.views.add( this.createAttachmentView( attachment ), {
! 					at: options.index
  				});
  			}, this );
  
--- 2901,2907 ----
  
  			this.collection.on( 'add', function( attachment, attachments, options ) {
  				this.views.add( this.createAttachmentView( attachment ), {
! 					at: this.collection.indexOf( attachment )
  				});
  			}, this );
  
***************
*** 3469,3475 ****
  			// Build `<option>` elements.
  			this.$el.html( _.chain( this.filters ).map( function( filter, value ) {
  				return {
! 					el: this.make( 'option', { value: value }, filter.text ),
  					priority: filter.priority || 50
  				};
  			}, this ).sortBy('priority').pluck('el').value() );
--- 3136,3142 ----
  			// Build `<option>` elements.
  			this.$el.html( _.chain( this.filters ).map( function( filter, value ) {
  				return {
! 					el: $('<option></option>').val(value).text(filter.text)[0],
  					priority: filter.priority || 50
  				};
  			}, this ).sortBy('priority').pluck('el').value() );
***************
*** 3964,3971 ****
  		},
  
  		updateChanges: function( model, options ) {
! 			if ( options.changes )
! 				_( options.changes ).chain().keys().each( this.update, this );
  		}
  	});
  
--- 3631,3638 ----
  		},
  
  		updateChanges: function( model, options ) {
! 			if ( model.hasChanged() )
! 				_( model.changed ).chain().keys().each( this.update, this );
  		}
  	});
  
***************
*** 4017,4023 ****
  				$input = this.$('.link-to-custom'),
  				attachment = this.options.attachment;
  
! 			if ( 'none' === linkTo || ( ! attachment && 'custom' !== linkTo ) ) {
  				$input.hide();
  				return;
  			}
--- 3684,3690 ----
  				$input = this.$('.link-to-custom'),
  				attachment = this.options.attachment;
  
! 			if ( 'none' === linkTo || 'embed' === linkTo || ( ! attachment && 'custom' !== linkTo ) ) {
  				$input.hide();
  				return;
  			}
***************
*** 4236,4251 ****
  		},
  
  		initialize: function() {
! 			this.input = this.make( 'input', {
! 				type:  'text',
! 				value: this.model.get('url') || ''
! 			});
! 
! 			this.spinner = this.make( 'span', {
! 				'class': 'spinner'
! 			});
  
! 			this.$input = $( this.input );
  			this.$el.append([ this.input, this.spinner ]);
  
  			this.model.on( 'change:url', this.render, this );
--- 3903,3912 ----
  		},
  
  		initialize: function() {
! 			this.$input = $('<input/>').attr( 'type', 'text' ).val( this.model.get('url') );
! 			this.input = this.$input[0];
  
! 			this.spinner = $('<span class="spinner" />')[0];
  			this.$el.append([ this.input, this.spinner ]);
  
  			this.model.on( 'change:url', this.render, this );
***************
*** 4302,4305 ****
  			this.$('img').attr( 'src', this.model.get('url') );
  		}
  	});
! }(jQuery));
--- 3963,3966 ----
  			this.$('img').attr( 'src', this.model.get('url') );
  		}
  	});
! }(jQuery));
\ No newline at end of file
